public class LivroInfantil extends Livro
{
	private String colecao = null;

	public LivroInfantil(int codigo, String nome, String editora, int ano, String colecao)
	{
		super(codigo, nome, editora, ano);
		this.colecao = colecao;
	}

	public void imprime()
	{
		System.out.println("LivroInfantil");
		System.out.println(nome+", "+editora+", "+ano+", "+colecao);
	}

	public static void main (String args[])
	{
		LivroTecnico lt = new LivroTecnico(1, "Tutorial Java", "Sun Microsystems", 1992, 
			"java, orientao a objetos, pacotes");
		LivroInfantil li = new LivroInfantil(2, "Branca de Neve", "Editora Infantil", 1931, 
			"princesa, anes");

		System.out.println("Criando um objeto LivroTecnico e outro LivroInfantil");
		lt.imprime();
		li.imprime();

		// o \n dentro do System.out.println faz pular uma linha
		System.out.println("\n\nFazendo um Cast do Objeto LivroTecnico para Livro");
		Livro lv1 = (Livro) lt;
		lv1.imprime();

		System.out.println("\n\nFazendo um Cast do Objeto LivroInfantil para Livro");
		Livro lv2 = (Livro) li;
		lv2.imprime();

		// System.out.println("\n\nForando um Cast de LivroInfantil para Livro Tecnico");
		// System.out.println("Este Cast  fora da hierarquia de classes");
		// System.out.println("Portanto no funciona!");
		// LivroInfantil li1 = new LivroInfantil(1, "livro infantil", "editora de livros", 1998, 
		// 	"coleo infantil");
		// LivroTecnico tc1 = (LivroTecnico) li1;
		// A converso forada (Cast) funciona somente entre classes filhas para 
		// com classes-pai! A converso portanto no funciona entre ramificaes de 
		// classes que pertencem a estruturas hierarquicas diferentes!
		// A converso funciona no sentido das subclasses para as superclasses, portanto  
		// possvel converter um objeto do  tipo LivroTecnico em Livro e  possvel 
		// converter LivroInfantil em Livro. Entretanto no  possvel converter 		
		// LivroTecnico em LivroInfantil e vice-versa, pois pertencem a ramificaes 
		// diferentes na hierarquia e nenhuma das classes  subclasse ou superclasse 
		// da outra.

		// Fazendo uma converso forada de um objeto do Tipo da classe-pai 
		// para a classe-filha

		System.out.println("\n\nFazendo um cast do Pai para o Filho...");
		try
		{
			LivroTecnico _lt = (LivroTecnico) new Livro(7, "o livro", "a editora", 2001);
			_lt.imprime();
		}
		catch(Exception e)
		{
			System.out.println("No foi possvel fazer o cast...");
		}
		// Este cast de Pai para Filho no funciona, pois o que existe no filho no existe 
		// no pai, entretanto o que existe no pai existe no filho! Assim, pode-se converter 
		// um filho no pai, mas no o contrrio. Isto  possvel, pois na herana todo 
		// o cdigo do pai foi passado para o filho. Entretanto converter o pai no filho 
		// gera erros, pois o pai no contm todo o cdigo do filho.		
        }
}