class LivroTecnico extends Livro
{
	protected String palavras_chave = null;
	public LivroTecnico()
	{
		// chama o construtor da classe pai (superclasse) sem parmetros
		super();                          
		palavras_chave = "sem palavras-chave";
	}

	public LivroTecnico(int codigo, String nome, String editora, int ano, 
		String palavras_chave)
	{
		super(codigo, nome, editora, ano);
		this.palavras_chave = palavras_chave;
	}
	public void testeMensagens()
	{
		// acessar private int cdigo da classe-pai gera erros, pois um atributo 
		// private somente  acessvel pela prpria classe, mesmo herdando
		// da classe que tem o atributo private, no  possvel acess-lo diretamente! 
		// todo atributo protected   acessvel pela prpria classe e pelas classes que 
		// herdarem da classe que os contm
		System.out.println("valor de protected String nome -> "+nome);

		// acessando public String editora quando um atributo ou mtodo  public
		// ele pode ser acessado diretamente por qualquer objeto
		System.out.println("valor de public String editora -> "+editora);

		// acessando int ano neste caso no h modificadores, qualquer classe-filha
		// ou pertencente ao mesmo pacote pode acess-la
		System.out.println("valor de <sem modificadores> int ano-> "+ano);

		// acessando protected String palavras_chave
		System.out.println("protected String palavras_chave -> "+palavras_chave);
	}

	public void imprime()
	{
		System.out.println("LivroTecnico");
		System.out.println(nome+", "+editora+", "+ano+", "+palavras_chave);
	}
	public static void main(String args[])
	{
		LivroTecnico lt = new LivroTecnico(1, "Linguagens", "Novatec", 2001, 
			"c, c++, java, orientao a objetos");
		lt.testeMensagens();

		Livro lv = new Livro(5, "O Livro Externo", "A Editora", 1930);

		// acessando de forma externa, ou seja, o envio da mensagem para o objeto
		// no  feito dentro da classe
		// System.out.println("Acessando o atributo private int codigo => "+lv.codigo);
		// isto no funciona, pois private somente  acessvel dentro da classe que 
		// declara o atributo

		System.out.println("Acessando o atributo protected String nome => "+lv.nome);
		System.out.println("Acessando o atributo public editora => "+lv.editora);

		//  acessvel pois est no mesmo pacote!

		System.out.println("Acessando atributo <sem modificador> int ano => "+lv.ano);
	}       
}