public class Livro extends Item {
	// atributos
	protected String editora;
	protected String autor;

	// construtores
	public Livro()
	{
		// ATENO: A palavra 'super' faz uma chamada para o construtor da classe-pai. 
		// super deve ser utilizado dentro do construtor da classe-filha que pede para que 
		// a classe-pai inicie certos dados. super deve sempre ser a primeira chamada 
		// dentro do construtor da classe-filha. No  obrigatrio o uso de super no caso 
		// abaixo. Mas neste caso est se requisitando que a classe-pai inicie seus dados, 
		// enquanto a classe-filha inicia somente os dados que lhe cabem, ou seja, a 
		// editora e o autor que foram declarados nesta classe.
		super();
		editora = "";
		autor = "";
		}
	public Livro(int codigo, String descricao, int edicao, int quantidadeTotal, 
		int quantidadeDisponivel, String local, int volume, String editora, String autor)
	{
		// chamando construtor do pai com os parmetros abaixo
		super(codigo, descricao, edicao, quantidadeTotal, quantidadeDisponivel, local, 
			volume);
		this.editora = editora;
		this.autor = autor;
	}

	// mtodos
	public void setEditora(String editora)
	{
		this.editora = editora;
	}
	public void setAutor(String autor)
	{
		this.autor = autor;
	}
	public String getEditora()
	{
		return editora;
	}
	public String getAutor()
	{
		return autor;
	}

	// insere dados do Livro, este mtodo utiliza o inserir da classe-pai por meio da 
	// chamada super.insert(), super funciona como o this, ou seja, super  um
	// ponteiro para o objeto do tipo Pai, assim quando se quer executar alguma
	// chamada do pai deve-se utilizar super! somente nos construtores 
	//  obrigatrio o uso de super como a primeira chamada!

	public void inserir()
	{
		super.inserir();     

		System.out.print("Editora: ");

		try {
			byte dado[] = new byte[100];
			System.in.read(dado);
			this.editora = new String(dado);                        
			this.editora = this.editora.trim();
		} catch (Exception e) {}

		System.out.print("Autor: ");

		try {
			byte dado[] = new byte[100];
			System.in.read(dado);
			this.autor = new String(dado);
			this.autor = this.autor.trim();
		} catch (Exception e) {}
	}

	// imprime os dados do Livro, este mtodo utiliza o super para fazer uma chamada 
	// para o mtodo imprime da classe-pai, reutilizando o cdigo-fonte e no sendo 
	// necessrio reescrever tudo que est na classe-pai nesse mtodo
	public void imprime()
	{
		super.imprime();
		System.out.println("Editora: "+this.editora);
		System.out.println("Autor: "+this.autor);
	}
}