import java.sql.*;

public class AcessoBanco {
    
	// declarao do objeto Connection que possibilita o acesso ao banco de dados
	private Connection con;

	// URL para o banco de dados, nesta fica o protocolo utilizado para acesso  base 
	// de dados, em seguida o nome da base de dados, dois pontos e o caminho
	// para o computador e diretrio que armazena a base criada no Interbase

	String url = "jdbc:interbase://localhost/c:/teste.gdb";

	// caminho completo para acesso  classe que representa o driver de acesso 
	// ao banco de dados. Este driver fica dentro da API cliente do banco.

	String driver = "interbase.interclient.Driver";

	// login e senha para acesso ao banco
	private String meuLogin = "SYSDBA";
	private String minhaSenha = "masterkey";

	// construtor vazio que executa todas as operaes sobre o banco usando os 
	// mtodos da classe AcessoBanco
	public AcessoBanco() 
	{
		// caso tenha criado a conexo execute as operaes
		if (criarConexao(url, driver, meuLogin, minhaSenha))
		{
			// clasula SQL que cria uma tabela no banco de dados
			String stringCriacaoTabela = "create table CLIENTE " +
				"(NOME VARCHAR(32), " +
				"CODIGO INTEGER, " +
				"SALDO FLOAT, " +
				"VENDAS INTEGER, " +
				"TOTAL INTEGER)";

     			System.out.println("Criando as tabelas...");

			// enviando o script sql para criar as tabelas
			executaAtualizacao(stringCriacaoTabela);
			System.out.println("Inserindo na tabela");

			// executando scripts sql para inserir dados na tabela criada
			executaAtualizacao("INSERT INTO CLIENTE VALUES ('Joo', 1, 8.99, 0, 0)");
			executaAtualizacao("INSERT INTO CLIENTE VALUES ('Ramon', 2, 9.99, 0, 0)");
			executaAtualizacao("INSERT INTO CLIENTE VALUES ('Rodrigo', 3, 8.99, 0, 0)");
			executaAtualizacao("INSERT INTO CLIENTE VALUES ('Renato', 4, 9.99, 0, 0)");

			System.out.println("Selecionando tuplas (linhas da tabela)...");
			// executa uma consulta sobre o banco de dados e recuperando a informao
			
			try 
			{
				// montando o script sql para selecionar linhas da tabela
				String stringDeConsulta = "select NOME, SALDO from CLIENTE";

				// enviando o script sql para selecionar linhas da tabela
				ResultSet rs = executeQuery(stringDeConsulta);

				// fazendo um lao de repetio para capturar cada uma das linhas obtidas 
				// como resultado do script sql
				while (rs.next()) 
				{
					// obtendo a coluna NOME de uma das linhas da tabela esta coluna 
					// est armazenada como string, por isto  utilizada a chamada getString
					String s = rs.getString("NOME");
					// obtendo a coluna SALDO que est armazenada como um valor 
					// numrico com casas decimais
					float f = rs.getFloat("SALDO");
					String texto = s + "     " + f;
					System.out.println(texto);
				}
			} 
			catch(SQLException ex) 
			{
				System.out.println("SQLException: " + ex);
			}

			System.out.println("Executando update...");
			// montando um script sql para executar alteraes sobre as linhas 
			// armazenadas na tabela
			String stringDeAtualizacao = 
				"UPDATE CLIENTE SET VENDAS = 75 WHERE NOME LIKE 'Rodrigo'";
			// executando as alteraes
			executaAtualizacao(stringDeAtualizacao);
           
			System.out.println("Selecionando tuplas aps alterao nos dados");

		  	// executando uma consulta sobre o banco de dados e recuperando a 
			// informao
			try 
			{
				// montando o script sql para selecionar linhas da tabela
				String stringDeConsulta = "select NOME, SALDO from CLIENTE";
	
				// enviando o script sql para selecionar linhas da tabela
				ResultSet rs = executeQuery(stringDeConsulta);

				// fazendo um lao de repetio para capturar cada uma das linhas obtidas 
				// como resultado do script sql
		    		while (rs.next()) 
				{
					// obtendo a coluna NOME de uma das linhas da tabela esta coluna 
					// est armazenada como String, por isto  utilizada a chamada getString
					String s = rs.getString("NOME");
					// obtendo a coluna SALDO que est armazenada como um valor 
					// numrico com casas decimais
					float f = rs.getFloat("SALDO");
					String text = s + "     " + f;
					System.out.println(text);                
				}
			}
			catch(SQLException ex)
			{
            			System.out.println("SQLException: " + ex);
	  		}

			// neste trecho de cdigo  iniciada a execuo de um script prepared, que
			//  montado no banco e para execut-lo basta enviar os parmetros. 
			// Esta tcnica  muito til para aumento de desempenho de scripts sql que 
			// devem ser executados vrias vezes usando diferentes parmetros.
			System.out.println("Executando um script sql usando prepare");
			// montando o vetor de vendas
			int [] vendasSemanais = {175, 150, 60, 155};
			// montando o vetor de clientes
         	 	String [] cliente = {"Rodrigo", "Joo", "Renato", "Ramon"};
			// executando o script prepared
			executaUsandoPrepare(vendasSemanais, cliente);

			System.out.println("Usando transaes...");
		   	// usando Transaes no banco de dados
		   	try 
			{
				// para usar transaes basta configurar a auto confirmao de execuo de 
				// scripts sql no banco para falso, desta forma somente aps uma chamada 
				// para commit sero atualizados os dados das tabelas
		  		con.setAutoCommit(false);
			
				// executando um script usando prepare
		  		executaUsandoPrepare(vendasSemanais, cliente);

				// aps executar o script  feito o commit e confirmada todas as operaes 
				// executadas no banco de dados. Pode-se executar vrias operaes e 
				// aps isto fazer o commit, caso uma operao venha a falhar pode-se 
				// cancelar as operaes executando um rollback
				con.commit();

				// configurando novamente a auto-confirmao de operaes sobre o banco 
				// de dados para verdadeira aps isto qualquer operao sobre o banco 
				// ser executada e em seguida os dados atualizados.
				con.setAutoCommit(true);
		    	}
		  	catch(SQLException ex) 
			{
				System.out.println("Exceo SQL: " + ex);
				try 
				{ 
					con.rollback(); 
				} 
				catch (Exception e) 
				{ 
					System.out.println("Falha na execuo do Rollback");
				}
		  	}

			System.out.println("Excluindo dados da tabela");
		  	// excluindo dados da tabela do banco de dados criado
			executaAtualizacao("DELETE FROM CLIENTE");
	
		  	// executando uma consulta sobre o banco de dados e recuperando a 
			// informao
			try 
			{
				String stringDeConsulta = "select NOME, SALDO from CLIENTE";
				ResultSet rs = executeQuery(stringDeConsulta);
				while (rs.next()) 
				{
					String s = rs.getString("NOME");
					float f = rs.getFloat("SALDO");
					String texto = s + "     " + f;
					System.out.println(texto);
				}
			} 
			catch(SQLException ex) 
			{
				System.out.println("Exceo SQL: " + ex);
			}
		}
		else
		{
			System.out.println("Conexo no foi criada com o banco de dados.");
		}
	}

	// o mtodo abaixo  responsvel por criar a conexo para acesso ao banco de dados
	private boolean criarConexao(String url, String driver, String login, String senha)
	{
		try
		{
			// carregando o driver contido na API cliente do banco para que seja montado 
			// um acesso ao banco de dados
			Class.forName(driver);

			// criando a conexo com o banco de dados
			con = DriverManager.getConnection(url, login, senha);
		}
		catch(java.lang.ClassNotFoundException e)
		{ 
			// manipula excees caso no encontre a classe do driver contido na API 
			// cliente para acesso ao banco de dados
			System.err.print("Classe do driver de banco de dados no encontrada: ");
			System.err.println(e.getMessage());
			return false;
		}
		catch (Exception e)
		{ 
			// manipulando exceo
			System.err.println(e.getMessage());
			return false;
		}
		return true;
	}

	// o mtodo abaixo executa um script sql prepared, que  analisado e caso
	// esteja correto  armazenado no cache do banco de dados e so submetidos 
	// parmetros para sua execuo. Esta execuo torna-se mais veloz, pois
	// este script foi analisado somente na sua fase de montagem.
	public boolean executaUsandoPrepare(int [] vendasSemanais, String[] cliente)
	{
		try 
		{
			PreparedStatement atualizaVendas; 
			String stringDeAtualizacao = "update CLIENTE set VENDAS = ? where NOME like ?"; 

			// montando o script sql prepared
	 	   	atualizaVendas = con.prepareStatement(stringDeAtualizacao);
			int len = cliente.length;

			// executando operaes sobre o script previamente montado, enviando os 
			// parmetros para que ele seja executado
		   	for(int i = 0; i < len; i++) 
			{ 
				atualizaVendas.setInt(1, vendasSemanais[i]);
				atualizaVendas.setString(2, cliente[i]);
				atualizaVendas.executeUpdate(); 
		    	}
		    	atualizaVendas.close();
			return true;
		}
		catch(SQLException ex) 
		{
          		System.out.println("Exceo SQL: " + ex);
			return false;
		}
	}

	// o mtodo abaixo executa um script sql sobre o banco de dados, entretanto esse 
	// script no pode ser prepared ou um seleo de linhas da tabela (SELECT)
	public boolean executaAtualizacao(String sql) 
	{
		try 
		{
			// criando um objeto Statement para que seja possvel enviar clsulas SQL 
			// para execuo no banco de dados
			Statement stmt = con.createStatement();

			// executando a clusula SQL para criar uma tabela no banco
			stmt.executeUpdate(sql);
			// finaliza o uso do objeto de envio de clsulas SQL
			stmt.close();
		}
		catch(SQLException ex)
		{
			// manipula excees
			System.err.println("Exceo SQL: " + ex.getMessage());
			return false;
		}
		return true;
	}

	// o mtodo abaixo  especfico para a execuo de SELECTS, ou seja, scripts sql para 
	// selecionar linhas da tabela
	public ResultSet executeQuery(String sql) {
		try 
		{
			Statement stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery(sql);	    		 
			stmt.close();
			return rs;
		}
		catch(SQLException ex)
		{
			System.out.println("Exceo SQL: " + ex);
			return null;
		}
	}

	// este mtodo inicia a execuo do exemplo
	public static void main(String args[]) 
	{
		// o construtor vazio executa todas as operaes
		AcessoBanco ac = new AcessoBanco();
	}      
}