import java.io.*;
import java.net.*;
public class ClienteDeEco 
{
	public static void main(String args[]) 
	{
		try 
		{
			// para se conectar a algum servidor, basta criar um objeto da classe Socket. O 
			// primeiro parmetro  o IP ou o endereo da mquina  qual se quer conectar 
			// e o segundo parmetro  a porta da aplicao. Neste caso, utiliza-se o IP da 
			// mquina local (127.0.0.1) e a porta da aplicao ServidorDeEco. Nada 
			// impede que se mude estes valores, tentando estabelecer uma conexo com 
			// outras portas em outras mquinas.
			Socket conexao = new Socket("127.0.0.1", 2000);
            
			// uma vez estabelecida a comunicao, deve-se obter os objetos que 
			// permitem controlar o fluxo de comunicao
			BufferedReader entrada = new BufferedReader(new 
				InputStreamReader(conexao.getInputStream()));
			PrintStream saida = new PrintStream(conexao.getOutputStream());
            
			// loop principal: obtm-se uma linha digitada no teclado e esta  enviada para o 
			// servidor. Logo em seguida, espera-se pela resposta do servidor, que neste 
			// caso (ServidorDeEco) ir retornar a mesma linha digitada.
			String linha;
			BufferedReader teclado = 
				new BufferedReader(new InputStreamReader(System.in));
			while (true) 
			{
				// l a linha do teclado
				System.out.print("> ");
				linha = teclado.readLine();
                
				// envia para o servidor
				saida.println(linha);
                
				// pega o que o servidor enviou
				linha = entrada.readLine();
                
				// agora, deve-se observar se o retorno do servidor  uma linha vlida, pois 
				// pode ser que a conexo tenha sido interrompida e, nesse caso, a linha  
				// null. Se isso ocorrer, termina-se a execuo saindo do loop com um break
				if (linha == null) 
				{
					System.out.println("Conexo encerrada!");
					break;
				}
                
				// caso a linha no seja nula, imprime-se ela
				System.out.println(linha);
			}
		} 
		catch (IOException e) 
		{
			// caso ocorra alguma exceo de I/O, mostre qual foi.
			System.out.println("IOException: " + e);
		}
	}
}