import java.io.*;
import java.net.*;

public class ServidorDeEco 
{
	public static void main(String args[]) 
	{
		try {
			// criando um socket que fica escutando a porta 2000.
			ServerSocket s = new ServerSocket(2000);
            
			// loop principal.
			while (true) 
			{
				// aguarda algum se conectar. A execuo do servidor fica bloqueada 
				// na chamada do mtodo accept da classe ServerSocket. Quando algum
				// se conectar ao servidor, o mtodo desbloqueia e retorna com um objeto 
				// da classe Socket, que  uma ponta da comunicao.
				System.out.print("Esperando algum se conectar...");
				Socket conexao = s.accept();
				System.out.println(" Conectou!");
                
				// obtendo os objetos que permitem controlar o fluxo de comunicao
				BufferedReader entrada = new BufferedReader(new 	
					InputStreamReader(conexao.getInputStream()));
				PrintStream saida = new PrintStream(conexao.getOutputStream());
                
				// esperando por alguma string do cliente e enviar de volta at que ele envie 
				// uma linha em branco. Deve-se primeiro verificar se a linha recebida 
				// no  nula (null). Isso pode ocorrer quando a conexao  interrompida 
				// pelo cliente. Se a linha no for null (o objeto existe)  que pode-se 
				// utilizar os mtodos de comparao de string (caso contrrio, estaria 
				// tentando chamar um mtodo de um objeto que no existe).
				String linha = entrada.readLine();
				
				while (linha != null && !(linha.trim().equals(""))) 
				{
					// envia a linha de volta.
					saida.println("Eco: " + linha);
					// espera por uma nova linha.
					linha = entrada.readLine();
				}
				// uma vez que o cliente enviou uma linha em branco, pode-se fechar 
				// a conexo.
				conexao.close();
                
				// e volta-se ao loop, esperando mais algum se conectar
			}
		} 
		catch (IOException e) 
		{
			// caso ocorra alguma exceo de I/O, mostre qual foi
			System.out.println("IOException: " + e);
		}
	}
}