import java.io.*;
import java.net.*;
public class ClienteDeChat extends Thread 
{
	// flag que indica quando se deve terminar a execuo
	private static boolean done = false;

	public static void main(String args[]) 
	{
		try 
		{
			// para se conectar a algum servidor, basta se criar um objeto da classe Socket
			// O primeiro parmetro  o IP ou o endereo da mquina  qual se quer 
			// conectar e o segundo parmetro  a porta da aplicao. Neste caso, utiliza-se
			// o IP da mquina local (127.0.0.1) e a porta da aplicao ServidorDeChat. 
			// Nada impede a mudana destes valores, tentando estabelecer 
			// uma conexo com outras portas em outras mquinas.
			Socket conexao = new Socket("127.0.0.1", 2222);
            
			// uma vez estabelecida a comunicao, deve-se obter os objetos 
			// que permitem controlar o fluxo de comunicao
			PrintStream saida = new PrintStream(conexao.getOutputStream());
            
			// o servidor de chat espera que seja enviado, antes de tudo, o 
			// nome do usurio
			BufferedReader teclado = 
				new BufferedReader(new InputStreamReader(System.in));
			System.out.print("Entre com o seu nome: ");
			String meuNome = teclado.readLine();
			saida.println(meuNome);
			// uma vez que tudo est pronto, deve-se, antes de iniciar o loop 
			// principal, executar a thread de recepo de mensagens
			Thread t = new ClienteDeChat(conexao);
			t.start();
			// loop principal: obtendo uma linha digitada no teclado e enviando 
			// para o servidor.
			String linha;
			while (true) 
			{
				// l a linha do teclado
				System.out.print("> ");
				linha = teclado.readLine();
                
				// antes de enviar, verifica se a conexo no foi fechada
				if (done) 
				{
					break;
				}
				// envia para o servidor
				saida.println(linha);
			}
		} 
		catch (IOException e) 
		{
			// caso ocorra alguma exceo de I/O, mostre qual foi.
			System.out.println("IOException: " + e);
		}
	}
    
	// -
	// parte da classe que controla o recebimento de mensagens
	// -
	
	// socket deste cliente
	private Socket conexao; 
    
	// construtor que recebe o socket deste cliente
	public ClienteDeChat(Socket s) 
	{
		conexao = s;
	}
    
	// execuo da thread
	public void run() 
	{
		try 
		{
			BufferedReader entrada = new BufferedReader
				(new InputStreamReader(conexao.getInputStream()));
			String linha;
            
			while (true) 
			{
				// pega o que o servidor enviou
				linha = entrada.readLine();
                
				// agora, deve-se ver se o que o servidor enviou  uma linha vlida porque
				// pode ser que a conexo tenha sido interrompida e, nesse caso, a linha 
				// null. Se isso ocorrer, termina-se a execuo saindo do loop com um break
				if (linha == null) 
				{
					System.out.println("Conexo encerrada!");
					break;
				}
				// caso a linha no seja nula, imprime-se ela
				System.out.println();
				System.out.println(linha);
				System.out.print("...> ");
			}
		} 
		catch (IOException e) 
		{
			// caso ocorra alguma exceo de I/O, mostre qual foi.
			System.out.println("IOException: " + e);
		}
		// sinaliza para o main que a conexo encerrou.
		done = true;
	}
}